<?php
/**
 * VBulletin Torrent Tracker (VBTT) v3.0
 * Coded by SqrtBoy (www.phpsoft.org)
 **/ 
 
// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'torrents');

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array('global','search',  'forumdisplay');

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by specific actions
$actiontemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array(
		'VBTT_Torrents_Page',
		'VBTT_Torrents_Bits'
);

// pre-cache templates used by specific actions
$actiontemplates = array();


// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/functions_bigthree.php');
require_once(DIR . '/includes/class_postbit.php');
require_once (DIR.'/includes/functions_search.php');
require_once(DIR . '/includes/functions_misc.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

$perpage = $vbulletin->options['vbtt_torrents_per_page'];

if ($perpage == '')
	$perpage = 30; // default value

if ($_REQUEST['sort'])
{
	$sort = (string) strtolower($_REQUEST['sort']);
			
	$valid_sort = array(
		'filename',
		'size',
		'dateline',
		'seeders',
		'leechers',
        'completed',
        'dlspeed',
        'ulspeed'
	);
			
	if (!in_array($sort, $valid_sort))
	{
		$sort = 'dateline';
	}
}
else
{
	$sort = 'dateline';
}
		
if ($_REQUEST['order'])
{
	$order = (string) strtolower($_REQUEST['order']);
			
	$valid_order = array(
		'desc',
		'asc'
	);
			
	if (!in_array($order, $valid_order))
	{
		$order = 'desc';
	}
}
else
{
	$order = 'desc';
}

if ($_REQUEST['query'] != '')
{
	$query = sanitize_word_for_sql($_REQUEST['query']) ;
	$search .= "AND SUBSTRING_INDEX(filename, '.torrent',1) LIKE '%".$query."%'";	
}


if ($_REQUEST['mode'])
{
	$mode = (string) strtolower($_REQUEST['mode']);
			
	$valid_mode = array(
		'orphan',
		'latest',
		'top',
	);
			
	if (!in_array($mode, $valid_mode))
	{
		$mode = '';
		
	}
	else
	{
		if ($mode == 'orphan')
		{
			$search .= "AND seeders = 0";
		}	
		else if ($mode == 'latest')
		{
			$search_comp = "dateline DESC,";
		}
		else if ($mode == 'top')
		{
			$search_comp = "completed DESC,";
		}		
	}
}
else
{
	$mode = '';
}






$result = $db->query_first("
	SELECT COUNT(*) AS count 
	FROM ".TABLE_PREFIX."attachment
        WHERE info_hash != '' ".$search);

$pagenumber = $_REQUEST['page'] > 0 ? (int) $_REQUEST['page'] : 1;

$rows = $result['count'];


$pages = ceil($rows / $perpage);

if ($pagenumber < 1)
{
	$pagenumber = 1;
}
else if ($pagenumber > $rows)
{
	$pagenumber = $rows;
}

$minlimit = ($pagenumber - 1) * $perpage+1;
$maxlimit = ($pagenumber) * $perpage;

if ($maxlimit > $rows)
{
	$maxlimit = $rows;
	
	$minlimit = $minlimit > $rows ? $rows-$perpage : $minlimit;
}

$minlimit = $minlimit <= 0 ? 1 : $minlimit;

$pagenav = construct_page_nav($pagenumber, $perpage, $rows, 
	"torrents.php?$session[sessionurl]pp=$perpage&ltr=$selectedletter&sort=$sort&order=$order&mode=$mode&query=$query",''
);

$searchquery = "pp=$perpage&ltr=$selectedletter&sort=$sort&order=$order&mode=$mode&query=$query";




// #############################################################################
// start search timer
$searchstart = microtime();

$attachment = $db->query_read("
		SELECT attachmentid, userid, filename, filedata, visible, counter, size , dateline, postid, seeders, leechers, completed, ulspeed, dlspeed
		FROM " . TABLE_PREFIX . "attachment
        WHERE info_hash != '' ".$search."
		ORDER BY ".$search_comp."  $sort $order 
		LIMIT " . ($minlimit-1) . ", $perpage
		");
    $alt = 1;
    while ($attach = $db->fetch_array($attachment)) 
    {
        $alt = ($alt==1)?($alt+1):($alt-1); 

        $attach['alt'] = $alt;
        $attach['filename'] = preg_replace("/\.torrent/","",$attach['filename']);

		$temp = substr($attach["filename"],0,$vbulletin->options['vbtt_max_length']);
		
		if ($temp!=$attach["filename"]) $temp.='...';
		$attach["filename"] = $temp;
		
        $attach['dateline'] = gmdate('d/m/y', $attach['dateline']);
		//$username = $attach['username'];
        $attach['size'] = mksize($attach['size']);
        $attach['leechers'] = "<font color=\"" . (($attach['leechers']==0)?"red":"blue") . "\">" . $attach['leechers'] . "</font>";
        $attach['seeders'] = "<font color=\"" . (($attach['seeders']==0)?"red":"green") . "\">" . $attach['seeders'] . "</font>";
        
        if ($attach["ulspeed"] =="0")
		$attach["ulspeed"] = "<font color=red>".mksize($attach["ulspeed"]) ."/s"."</font>";
		else $attach["ulspeed"] = "<font color=green>".mksize($attach["ulspeed"]) ."/s"."</font>";

		$attach["dlspeed"] =  "<font color=blue>".mksize($attach["dlspeed"] )."/s"."</font>";
		
        eval('$torrents_bit .= "' . fetch_template('VBTT_Torrents_Bits') . '";'); 
    } 
	
// end search timer
$searchtime = vb_number_format(fetch_microtime_difference($searchstart), 2);
	
// #############################################################################
// show forum rules
construct_forum_rules($forum, $forumperms);	

// #############################################################################
// draw navbar
$navbits = array("torrents.php?$session[sessionurl]" => "Torrents");
$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

// #############################################################################
// output page

eval('print_output("' . fetch_template('VBTT_Torrents_Page') . '");');
?>
